'$lang: "fblite"
#include "dostime.bas"
#include "fbgfx.bi"
declare sub PlayDRO ()
declare sub LoadDRO (filename$)
declare sub LoadEntireDRO (filename$)
declare sub UnLoadDRO ()
declare sub ReloadDRO
declare sub RepeatDRO
declare sub KillDRO ()
declare sub ClearOPL ()
declare sub ResetOPL ()
declare sub getheader ()
declare sub oplchipdelay()
declare function drogetint()
declare function drogetdouble()

'DRO player code
'Collin Brockway 12/2017

dim shared opltimer as double, oplchip as integer, opldelay as double, oplescape as integer, oplfreq as double, oplindex as integer, oplsize as integer
'Array to hold music file:
dim shared oplarray(200000) as ushort
'Internal variables:
dim shared oplreg as ubyte, oplval as ubyte, tempbyte as ubyte, tempbyte2 as ubyte, tempshort as ushort

filename$ = COMMAND$

LoadEntireDRO (filename$)

'LoadDRO (filename$)








do
    'locate 10,10
    'print "opldelay: " + str$(opldelay) + "                                "
    'print "opltimer: " + str$(opltimer)
    'print "DosTimer: " + str$(DosTimer)
    
    PlayDRO
    
    if multikey(SC_ESCAPE) then exit do

loop


KillDRO


end





'========BEGIN SUBS==========


sub LoadDRO (filename$)
    if ucase$(right$(filename$,3)) = "IMF" then 
        print "IMF file"
        oplfreq = 560 'indicate that it's an IMF file
    elseif ucase$(right$(filename$,3)) = "DRO" then
        print "DRO file"
        oplfreq = 1000 'indicate that it's a DRO file
    else
        print "Not a DRO or IMF file!"
        print "Setting default frequency of 1000 Hz"
        oplfreq = 1000
    end if
    
    open filename$ for binary access read as #1
    'GET #1, 133, blah% 'set the starting point properly
    getheader
end sub

sub LoadEntireDRO (filename$)
    oplfreq = 1000 'Default frequency
    open filename$ for binary access read as #1
    'Detect file type:
    if right$(ucase$(filename$),3) = "DRO" then 'DRO type, this is easy:
        oplfreq = 1000 'DRO frequency is 1000 Hz
        print "DRO file"
        i = 0
        do
            get #1, , tempbyte
            oplarray(i) = tempbyte
            i = i + 1
        loop until (eof(1))
        oplindex = 16
        oplsize = i
    elseif right$(ucase$(filename$),3) = "IMF" then 'IMF file, this is more tricky:
        oplfreq = 560 'IMF frequency is 560 Hz, for Keen files, we don't care about anything else >=)
        print "IMF file"
        i = 0
        'Get the first two bytes to check the type of the file:
        get #1, , tempbyte
        get #1, , tempbyte2
        if tempbyte = 0 and tempbyte2 = 0 then 'Likely a Type 0 file
            print "Type 0 file"
            get #1, , tempshort 'Put us in the right spot
        else 'Likely a Type 1 file
            print "Type 1 file"
            'Do nothing, we're already in the right spot
        end if
        oplsize = 2
        do
            get #1, , tempbyte
            get #1, , tempbyte2
            get #1, , tempshort
            'Add the register and data values to the array:
            oplarray(i) = tempbyte
            oplarray(i+1) = tempbyte2
            oplarray(i+2) = tempshort
            i = i + 3
            oplsize = oplsize + 4
        loop until eof(1)
        oplindex = 0
    end if
    close
    print "Total size of file: " + str$(oplsize) + " bytes"
end sub

sub getheader ()
    'Skip over the header:
        blah$ = INPUT$(16, #1) '16 bytes total in the header

end sub

sub ReloadDRO
    'GET #1, 134, blah% 'set the starting point properly
end sub

sub UnLoadDRO
    close
end sub

sub KillDRO
    UnLoadDRO
    ResetOPL
end sub

sub RepeatDRO
    'GET #1, 0, blah% 'set the starting point properly
    'getheader
    if oplfreq = 1000 then oplindex = 16
    if oplfreq = 560 then oplindex = 0
    oplescape = 0
    opldelay = 0
    oplreg = 0
    oplval = 0
end sub

function drogetbyte()
    'tempbyte = ASC(oplarray(oplindex))
    oplindex = oplindex + 1
    if oplindex > oplsize then RepeatDRO:return 0
    'return tempbyte
    return oplarray(oplindex-1)
end function

function drogetshort()
    'tempbyte = ASC(oplarray(oplindex))
    'tempbyte2 = ASC(oplarray(oplindex + 1))
    'tempshort = tempbyte + (tempbyte2 shl 8)
    oplindex = oplindex + 2
    if oplindex > oplsize then RepeatDRO:return 0
    'return tempshort
    return oplarray(oplindex-2) + (oplarray(oplindex-1) shl 8)
end function

sub PlayDRO
    
    if oplindex > oplsize then RepeatDRO
    
    if opltimer = 0 then opltimer = DOSTimer
    
if opltimer - DOSTimer < 0.001 then
    
select case oplfreq
case 1000 'DRO file
    'Get a register value:
    opldelay = 0
    oplreg = drogetbyte()
    
    'Check what it says to do:
    if oplescape = 1 then oplescape = 0: goto doescape:
    
    
    IF oplreg = &H0 THEN 'delay
      tempbyte = drogetbyte()
      opldelay = tempbyte + 1 'opldelay is now our delay time in milliseconds
    ELSEIF oplreg = &H1 THEN  'long delay
      tempshort = drogetshort()
      opldelay = tempshort + 1 'opldelay is now our delay time in milliseconds
      if opldelay > 4000 then opldelay = 0 'remove anomolous delays (more than 4 sec)
    ELSEIF oplreg = &H2 THEN 'switch to "low" opl chip (primary registers)
      oplchip = 0
    ELSEIF oplreg = &H3 THEN 'switch to "high" opl chip (secondary registers)
      oplchip = 1 '&H100
    ELSEIF oplreg = &H4 THEN  'escape: treat the next pair as normal ("CASE ELSE")
      oplescape = 1
    ELSE
doescape:
  
      oplval = drogetbyte()
   
      
      IF oplreg <= &H100 THEN
         if oplchip = 0 then
            OUT &H220, oplreg
            OUT &H221, oplval
         else
            OUT &H222, oplreg
            OUT &H223, oplval
         end if
      ELSE
         OUT &H222, oplreg
         OUT &H223, oplval
      END IF

     
    END IF

case 560 'IMF file
    
    if oplindex > oplsize - 3 then RepeatDRO
    
    opldelay = 0
    'Get the next register, value, and delay:
    oplreg = drogetbyte()
    oplval = drogetbyte()
    opldelay = drogetbyte()

    'Play the register and value pair:
    OUT &H388, oplreg
    OUT &H389, oplval

    'locate 10,10
    'print "Playing"
    'print "Delay: "+str$(opldelay) + "                     "
end select
    
    'IF EOF(1) THEN RepeatDRO
    
    opltimer = DosTimer + (opldelay/oplfreq) 'Current time plus delay in milliseconds which might be 0 if there was no delay this time
    
end if

end sub

sub oplchipdelay()
    'for t = 0 to 1000
    'next t
end sub

sub ClearOPL
    
    'Clear out the OPL chip
    
    V% = 0
  FOR R% = 0 TO &HF5 'was &HF5
    OUT &H388, R%
    OUT &H389, V%
    OUT &H220, R%
    OUT &H221, V%
    OUT &H222, R%
    OUT &H223, V%

  NEXT R%

  R% = 1
  V% = 32
  OUT &H388, R%
  OUT &H389, V%
    OUT &H220, R%
    OUT &H221, V%
    OUT &H222, R%
    OUT &H223, V%
end sub

sub ResetOPL
    OUT &H43, &H36
    OUT &H40, &HFF
    OUT &H40, &HFF

    ClearOPL
    
end sub